// Trackball.h: Schnittstelle fr die Klasse Trackball.
//
//////////////////////////////////////////////////////////////////////

#if !defined(TRACKBALL_H)
#define TRACKBALL_H

class Trackball
{
	float curquat[4];
	int W, H;
	float ballsize;
	float scalefactor;
	int moving, scaling, beginx, beginy;
	void trackball(float q[4], float p1x, float p1y, float p2x, float p2y);
	static float project_to_sphere(float r, float x, float y);
	void build_rotmatrix(float m[4][4], float q[4]);
	void add_quats(float q1[4], float q2[4], float dest[4]);
#define TRACKBALLSIZE (0.8f)
public:
	Trackball(int w, int h, float trackballSize=0.8f);
	~Trackball();

	void setDimensions(int w, int h);
	void mouse(int button, int state, int x, int y);
	void motion(int x, int y);
	void rotate();
};

#endif // !defined(TRACKBALL_H__INCLUDED_)
